import { type Ref } from 'vue-demi';
import { type MaybeRef, type MaybeComputedRef } from '@vueuse/shared';
import { type Fn } from '@vueuse/core';
import type { Layer } from 'leaflet';
export interface UseLeafletToggleLayerOptions<Controls extends boolean> {
    initialValue?: MaybeRef<boolean>;
    controls?: Controls;
    flushSync?: boolean;
    dispose?: boolean;
}
export interface LeafletAddLayer {
    addLayer(layer: Layer): this;
    removeLayer(layer: Layer): this;
    hasLayer(layer: Layer): boolean;
}
export type UseLeafletToggleLayerReturn = (value?: boolean) => boolean;
export interface UseLeafletToggleLayerReturnWithControls {
    toggle: (value?: boolean) => boolean;
    value: Ref<boolean>;
    add: Fn;
    remove: Fn;
    has: () => boolean;
}
export declare function useLeafletToggleLayer(source: MaybeComputedRef<LeafletAddLayer | null | undefined>, target: MaybeComputedRef<Layer | null | undefined>, options?: UseLeafletToggleLayerOptions<false>): UseLeafletToggleLayerReturn;
export declare function useLeafletToggleLayer(source: MaybeComputedRef<LeafletAddLayer | null | undefined>, target: MaybeComputedRef<Layer | null | undefined>, options: UseLeafletToggleLayerOptions<true>): UseLeafletToggleLayerReturnWithControls;
